import 'dart:async';
import 'dart:typed_data';
import 'package:flutter/material.dart';
import 'package:observable/observable.dart';
import 'package:xfxbase/XFDataItem.dart';
import 'package:xfxbase/_XFX/XF_Col.dart';
import 'package:xfxbase/_XFX/XF_View.dart';
import 'package:xfxwidgets/XF_MAIN/XApp.dart';
import 'package:xfxwidgets/XF_MAIN/XAppState.dart';
import 'package:xfxwidgets/xMediaItem.dart';
import 'package:xfxwidgets/xfxwidgets.dart';
import 'package:xtoolspackage/xtoolspackage.dart';
import 'package:image/image.dart' as img;
import 'XElenco.dart';

class ElXBase_ElencoDraggable<T> extends XElenco<ElXBase_ElencoDraggable<T>, XFDataItem> {
  ElXBase_ElencoDraggable(
    this.viewToUse,
    this.title, {
    Key? key,
    super.liXMediaToUse,
    Widget? xDrawerMenu,
    this.liToUse,
    super.xApp,
    Function(T)? functToDelete,
    super.rootItemEdited,
    super.itemEdited,
    super.onTapItem,
    super.BTNEmptyList_BL,
    super.xLayout_Row_CellWidth,
    super.xLayout_Row_Cell,
    super.styleForItemCell,
  }) : super(
          title,
          viewToUse,
          pageMode_Active: true,
          liDetts: liToUse,
          onLongTapItem: functToDelete != null ? (item) => functToDelete(item) : null,
          xDrawerMenu: xDrawerMenu,
          key: key,
          title_Style: XStyles.xStyTextForTitle(textColor: XColors.foregroundLight),
          title_Color: (XColors.foregroundLight),
        );
  List<T>? liToUse;
  Function(T)? functToDelete;
  XView viewToUse;
  String title;
  @override
  ElXBase_ElencoDraggable_State<T> createState() => ElXBase_ElencoDraggable_State<T>();
}

class ElXBase_ElencoDraggable_State<T> extends XElencoState<ElXBase_ElencoDraggable<T>, XFDataItem> {}

class ElencoDraggable<T> extends ElXBase_ElencoDraggable<T> {
  ElencoDraggable(
    this.obj,
    this.title,
    this.viewToUse, {
    this.isSch = false,
    super.liXMediaToUse,
    super.xApp,
    super.liToUse,
    super.functToDelete,
    super.onTapItem,
    super.BTNEmptyList_BL,
    super.rootItemEdited,
    super.itemEdited,
    super.xLayout_Row_CellWidth,
    super.xLayout_Row_Cell,
    super.styleForItemCell,
  }) : super(viewToUse, title);
  T? obj;
  bool? isSch;
  XView viewToUse;
  String title;
  @override
  _El_ElencoDraggable_State<T> createState() => _El_ElencoDraggable_State<T>();
}

class _El_ElencoDraggable_State<T> extends ElXBase_ElencoDraggable_State<T> {
  late AnimationController _controller;
  @override
  void initState() {
    widget.view = (widget as ElXBase_ElencoDraggable).viewToUse;
    widget.schedaMode = (widget as ElencoDraggable).isSch;
    widget.xApp = (widget as ElXBase_ElencoDraggable).xApp;
    widget.allowAdd = true;
    widget.title_Text = (widget as ElXBase_ElencoDraggable).title;
    super.initState();
    widget.onLongTapItem = (p0) async => await widget.onLongTapItem!(p0);
    widget.onTapBack = () => Navigator.pop(context);
    _controller = AnimationController(
      vsync: this,
      duration: Duration(milliseconds: 300),
    )..repeat(reverse: true); // Ripete l'animazione all'indietro dopo che è completata
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  @override
  Widget? xLayout_ItemWidget(XFDataItem xItem) {
    var w = InkWell(
        onTapDown: (details) {
          xItem.isSel = true;
          Timer(Duration(seconds: 2), () {
            xItem.isSel = false;
          });
        },
        child: Draggable<XFDataItem>(
          data: xItem,
          onDragStarted: () {},
          child: AnimatedBuilder(
              animation: _controller,
              builder: (context, child) {
                return xItem.isSel
                    ? Transform.translate(
                        offset: Offset(10 * _controller.value, 0), // Valore di traslazione basato sull'animazione
                        child: Container(width: 300, child: super.xLayout_ItemWidget(xItem) ?? Container()))
                    : Container(width: 300, child: super.xLayout_ItemWidget(xItem) ?? Container());
              }),
          feedback: AnimatedBuilder(
              animation: _controller,
              builder: (context, child) {
                return xItem.isSel
                    ? Transform.translate(
                        offset: Offset(10 * _controller.value, 0), // Valore di traslazione basato sull'animazione
                        child: Container(width: 300, child: super.xLayout_ItemWidget(xItem) ?? Container()))
                    : Container(width: 300, color: Colors.white, child: super.xLayout_ItemWidget(xItem) ?? Container());
              }),
          childWhenDragging: AnimatedBuilder(
              animation: _controller,
              builder: (context, child) {
                return xItem.isSel
                    ? Transform.translate(
                        offset: Offset(10 * _controller.value, 0), // Valore di traslazione basato sull'animazione
                        child: Container(width: 300, child: super.xLayout_ItemWidget(xItem) ?? Container()))
                    : Container(width: 300, color: Colors.white, child: super.xLayout_ItemWidget(xItem) ?? Container());
              }),
        ));
    return w;
  }
}
